# #
# $Date: 1996/06/20 12:17:32 $  $Author: frankp $   $Revision: 1.15 $ #
# #
# frankp, 24/02/94 #

#++
  concat.mu

	linalg::concatMatrix  --  inserts matrices horizontally

	concatMatrix(A [,B,C,...])

	Appends matrices B,C,.. to A horizontally. The matrices
	B,C,... are converted to matrices of type of A.
	If A is of type SquareMatrix then A is converted to Matrix.
++#

linalg::concatMatrix := proc(A)
    name linalg::concatMatrix;
    local i, r, B, t, p;
begin
    if testargs() then
	if args(0) < 1 then error("wrong no of args") end_if;
	if A::hasProp( Cat::MatrixCat ) <> TRUE then
	    error("expecting matrices")
	end_if;
	if A::hasProp( Cat::SquareMatrixCat ) then
	    B := A::getSuperDomain(A)
	else
	    B := type(A)
	end_if;
	r := op(A::dimen(A),1);
 	t := [args()];
	t[1] := NIL;
        for i in t do
	    if not testtype( i,B ) then
		error("types of matrices don't match")
	    end_if;
            if op(i::dimen(i),1) <> r then
                error("matrices are not compatible")
            end_if
        end_for
    end_if;

    if args(0) = 1 then return( A ) end_if;

    if A::hasProp( Cat::SquareMatrixCat ) then
	A := A::convert_to( A,A::getSuperDomain(A) )
    end_if;

    r := A::concatMatrix;
    t := A::convert;
    p := [args()];
    p[1] := NIL;
    for i in p do
	B := t( i );
	if B = FAIL then B := i::convert_to( i,type(A) ) end_if;
	A := r( A,B )
    end_for;

    A
end_proc:

# end of file #
