# temporary implementation until the assume library works #

alias(Is=stdlib::is):

assume:=proc(p)
begin
   if type(p)="_less" then
      stdlib::syseval((
         Is(op(p,1),Type::RealNum):=TRUE;
         Is(op(p,2),Type::RealNum):=TRUE;
         sign(op(p,2)-op(p,1)):=1;
      )): # of stdlib::syseval(( #
   end_if;
   sysassign(Is(args()), TRUE)
end_proc:

# delete all properties about x #
unassume:=proc(x) local _v;
begin
   if type(x)<>DOM_IDENT then x:=indets(x) else x:={x} end_if;
   if (_v:=op(Is,5))<>NIL then
      sysassign(Is,subsop(Is,5=table(op(select([op(_v)],not has,x)))))
   end_if;
   for _v in x do sysassign(sign(_v), NIL) end_for;
   null()
end_proc:

Type::real:=Type::RealNum: # because assume and Type use different names #

is:=proc() local b;
begin
   b:=Is(args());
   userinfo(2,args()," ==> ",b);
   b
end_proc:

# is(a>b) is(a>=b) is(a=b) is(a,Type::NonNegInt) #
Is := proc(e,t) local s;
begin
   if args(0)=2 then
      if t=Type::RealNum then 
         if contains({"Re","Im"},type(e)) then return(TRUE) end_if;
         # try to use sign for constants #
         if testtype(e,Type::Constant) then
	    if contains({-1,0,1},(s:=sign(e))) then return(TRUE)
	    elif has(s,hold(sign)) then return(UNKNOWN)
	    else return(FALSE)
	    end_if
         elif contains({"_plus","_mult"},type(e)) then
            for s from 1 to nops(e) do
               if Is(op(e,s),Type::RealNum)<>TRUE then break end_if
            end_for;
            if s>nops(e) then return(TRUE) end_if
         elif type(e)="_power" then
            if type(op(e,2))=DOM_INT then
               if Is(op(e,1),Type::RealNum)=TRUE then return(TRUE) end_if
            end_if
         elif type(e)=DOM_IDENT and Is(e,DOM_INT)=TRUE then return(TRUE)
         end_if
      elif t=DOM_INT then
         case type(e)
         of DOM_INT do return(TRUE)
         of DOM_RAT do return(FALSE)
         of DOM_IDENT do
	    if (Is(e,Type::PosInt) or Is(e,Type::NonNegInt) or
		Is(e,Type::NegInt))=TRUE then return(TRUE) end_if
         end_case
      elif t=Type::NonNegInt then
         return((if type(e)=DOM_INT then bool(e>0)
	         elif Is(e,Type::PosInt)=TRUE then TRUE else UNKNOWN end_if))
      end_if;
      # if testtype returns FALSE, the property may be true #
      return((if testtype(e,t)=TRUE then TRUE else UNKNOWN end_if))
   end_if;
   if type(e)="_less" then
      case sign((s:=op(e,2)-op(e,1)))
      of 1 do return(TRUE)
      of 0 do of -1 do return(FALSE)
      otherwise
         case type(s) of "_plus" do
            for t from 1 to nops(s) do
               if Is(op(s,t)>=0)=TRUE and Is(subsop(s,t=0)>0)=TRUE then
		  return(TRUE) end_if
            end_for; return(UNKNOWN)
         of "_mult" do
            e:=TRUE;
            for t in s do if Is(t>0)<>TRUE then e:=UNKNOWN; break end_if end_for;
            if e=UNKNOWN and nops(s)=2 and op(s,2)=-1 then
               if Is(op(s,1)>0)=TRUE then e:=FALSE end_if
            end_if;
            return(e);
         of DOM_IDENT do
	    if Is(s,Type::PosInt)=TRUE then return(TRUE) end_if; break
         of "_power" do
	    if (Is(op(s,1)>0) and Is(op(s,2),Type::RealNum))=TRUE then return(TRUE)
	    end_if
         end_case
      end_case
   elif type(e)="_leequal" then
      case (s:=sign((t:=op(e,2)-op(e,1))))
      of 1 do of 0 do return(TRUE)
      of -1 do return(FALSE)
      otherwise
         if type(s)="sign" and type(op(s))="Re" then
            if type(op(s,[1,1]))="_power" then
               # 0<=Re(x^(1/n)) is always true #
               if testtype(1/op(s,[1,1,2]),Type::PosInt) then return(TRUE) end_if
            end_if
         elif type(s)="_power" and type(op(s,1))="sign" then
            if Is(op(s,[1,1]),Type::RealNum)=TRUE and type(op(s,2)/2)=DOM_INT then
               return(TRUE) # sign(x)^(2*k)=1 when x is real #
            end_if
         elif type(t)=DOM_IDENT and Is(t,Type::NonNegInt)=TRUE then return(TRUE)
         elif type(op(e,2))="_plus" then
	    if contains({"sin","cos"},type(op(e,[2,1]))) then
               return(Is(op(e,1)<=subsop(op(e,2),1=-1)))
            else
               s:=TRUE; for t in op(e,2) do
                  s:=s and Is(t>=0);
                  if s<>TRUE then break end_if
               end_for;
               if s=TRUE then return(s) end_if
            end_if
         end_if;
         if op(is,5)<>NIL and op(is,5)[-op(e,1)>=-op(e,2)]=TRUE 
         then return(TRUE) end_if;
         return(Is(subsop(e,0=_less))) # a<b ==> a<=b #
      end_case
   elif type(e)="_equal" then
      case sign(op(e,1)-op(e,2))
      of 0 do return(TRUE)
      of -1 do of 1 do return(FALSE)
      end_case
   end_if;
   UNKNOWN
end_proc:
